import numpy as np
import sys
import homcloud.interface as hc


def main():
    if sys.argv[1] == "generate-data":
        n = int(sys.argv[2])
        generate_data(n)
    elif sys.argv[1] == "compute-pd":
        n = int(sys.argv[2])
        compute_pd(n)
    elif sys.argv[1] == "optimal-volume":
        optimal_volume(int(sys.argv[2]), *map(float, sys.argv[3:]))
    
def data_path(n):
    return f"data_{n}.npy"


def pdgm_path(n):
    return f"data_{n}.pdgm"


def generate_data(n):
    np.savetxt(data_path(n), np.random.uniform(-1.0, 1.0, (n, 3)))


def compute_pd(n):
    hc.PDList.from_alpha_filtration(np.loadtxt(data_path(n)), save_boundary_map=True,
                                    save_to=pdgm_path(n))


def optimal_volume(n, x, y, r):
    pd1 = hc.PDList(pdgm_path(n)).dth_diagram(1)
    pair = pd1.nearest_pair_to(x, y)
    print(pair)
    pair.optimal_volume(r)


main()
