import numpy as np
import sys
import homcloud.interface as hc
from scipy.ndimage import gaussian_filter


def main():
    if sys.argv[1] == "generate-data":
        n = int(sys.argv[2])
        generate_data(n)
    elif sys.argv[1] == "compute-pd":
        n = int(sys.argv[2])
        compute_pd(n)
    # elif sys.argv[1] == "optimal-volume":
    #     optimal_volume(int(sys.argv[2]), *map(float, sys.argv[3:]))
    

def data_path(n):
    return f"data_{n}.npy"


def pdgm_path(n):
    return f"data_{n}.pdgm"


def generate_data(n):
    data = np.zeros((n, n, n), dtype=float)
    for _ in range(n * n * n // 20):
        x, y, z = np.random.randint(n, size=3)
        data[x, y, z] += 1
    data = gaussian_filter(data, 2) >= 0.05
    print(np.mean(data))
    np.save(data_path(n), data)
    

def compute_pd(n):
    hc.PDList.from_bitmap_levelset(np.load(data_path(n)), save_to=pdgm_path(n))


main()
