import numpy as np
import sys
import homcloud.interface as hc


def main():
    if sys.argv[1] == "generate-data":
        n = int(sys.argv[2])
        generate_data(n)
    elif sys.argv[1] == "compute-pd":
        n = int(sys.argv[2])
        compute_pd(n)
    # elif sys.argv[1] == "optimal-volume":
    #     optimal_volume(int(sys.argv[2]), *map(float, sys.argv[3:]))
    

def data_path(n):
    return f"data_{n}.npy"


def pdgm_path(n):
    return f"data_{n}.pdgm"


def generate_data(n):
    np.save(data_path(n), np.random.uniform(size=(n, n, n)))
    

def compute_pd(n):
    hc.PDList.from_bitmap_levelset(np.load(data_path(n)), save_to=pdgm_path(n))


main()
